#ifdef OUTPUT_AVI
#define PROGRAMNAME "CaptureAVI"
#else
#define PROGRAMNAME "Capture"
#endif

#define VERSION "0.2.0"
/*
 * Capture -- grabbing DV data
 *
 * Copyright (C) May 2000 Bonin Franck <boninf@free.fr>. 
 *
 * Maintly based on :
 * libdv Copyright (C) Charles 'Buck' Krasic - April 2000
 *       Copyright (C) Erik Walthinsen - April 2000.
 * dvaudio Copyright (C) 2000 - Alastair JW Mayer 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#include "capture.h"


#include "playdv.h"
/** PROTOTYPES**/

void signal_handler(int sig);

int close_capture(capture_t *capture);

/** Seulement pour les signaux **/
/** Only for SIG handlers **/
capture_t *capture_globale;

int raw_iso_handler(raw1394handle_t handle, int channel, size_t length, quadlet_t *data) {
  capture_t *capture = (capture_t*)raw1394_get_userdata(handle);
  unsigned char* g_frame =  (unsigned char*) data;

  if (length == SIZE_BIG_PACKET) {
    if (!capture->g_found_first_frame) {
      if (g_frame[12] == 0x1f && g_frame[13] == 0x07) {
	fprintf(stderr,"Receiving...\n");
	capture->g_found_first_frame = true;
	/** We are waiting for g_nb_packet_frameper picture **/
	capture->g_nb_packet_attendu = capture->g_nb_packet_frame; 
	/** Clean quit **/
	signal(SIGINT, signal_handler);
	/** Starting players **/
	if (capture->g_view) pthread_create(&(capture->player_video), NULL, (void * (*)(void *))playdv, capture);
	if (capture->g_son) pthread_create(&(capture->player_son), NULL, (void * (*)(void *))playdv_audio, capture);

      } else if (capture->g_skipped > 10000) {
	fprintf(stderr,"skipped too many without finding frame\n");
	exit(0);
      } else {
	capture->g_skipped++;
      }
    } 
    if (capture->g_found_first_frame) {
      if (g_frame[12] == 0x1f && g_frame[13] == 0x07) {
	/** This is the begining of a new image **/
	if (capture->g_nb_packet_attendu == 0) {
	  /* Tout vas bien, on sauvegarde l'image courante */
	  /** We may have saved an image so we feed players **/
	  if (capture->g_file_out) {
#ifdef OUTPUT_AVI
	    switch (capture->g_avi_format){
	    case 0 :
	      write(capture->g_fo, capture->start_g_frame_data, capture->g_frame_size);
	      break;
	    case 1 :
	    case 2 :
	      capture->g_avi->WriteFrame(capture->start_g_frame_data, capture->g_frame_size);
	      break;
	    }
#else
	    write(capture->g_fo, capture->start_g_frame_data, capture->g_frame_size);
#endif
	  }
	  if (capture->g_view) bwrite((capture->b_video), capture->start_g_frame_data, capture->g_frame_size);
	  if (capture->g_son) bwrite((capture->b_son), capture->start_g_frame_data, capture->g_frame_size);
	  if (capture->g_stdout) write(1, capture->start_g_frame_data, capture->g_frame_size);
	  /* On commence l'image suivante */
	  /** Next image **/
	  capture->g_frame_read++;
	  /** Start saving the next picture (and its audio track) **/
	  memcpy(capture->g_frame_data, (data+3), SIZE_FRAME);
	  /* Nombre de paquet attendus */
	  /** We are waiting for g_nb_packet_frame-1 for this image **/
	  capture->g_nb_packet_attendu = capture->g_nb_packet_frame - 1; 
	  /** we should update the data saving pointer **/
	  capture->g_frame_data = capture->start_g_frame_data + SIZE_FRAME;
	} else if (capture->g_nb_packet_attendu < capture->g_nb_packet_frame){
	  /* Il manque des bouts de l'image precedente ! */
	  /** We have lost some packets from the previous image : we drop it **/
	  fprintf(stderr,"Lost %d frames from image %d\n", capture->g_nb_packet_attendu, capture->g_frame_read);
	  /* On recuper le le premier bloc de la nouvelle image */
	  /** Copying new image start **/
	  memcpy(capture->start_g_frame_data, (data+3), SIZE_FRAME);
	  /* Nombre de paquet attendus */
	  /** We are waiting for g_nb_packet_frame - 1 for this image **/
	  capture->g_nb_packet_attendu = capture->g_nb_packet_frame - 1; 
	  capture->g_frame_data = capture->start_g_frame_data + SIZE_FRAME;
	} else {
	  /** Save the first frame of the first picture (and its audio track) **/
	  memcpy(capture->g_frame_data, (data+3), SIZE_FRAME);
	  capture->g_nb_packet_attendu--; 
	  /** we should update the data saving pointer **/
	  capture->g_frame_data += SIZE_FRAME;
	}
      } else if (capture->g_nb_packet_attendu == 0) {
	/* On a perdu le debut d'une image, on attend la suivante... */
	/** We have lost the image start, we skip everything until next image **/
	//fprintf(stderr,"Skip image %d \n", capture->g_frame_read);
	capture->g_frame_data = capture->start_g_frame_data;
      } else {
	/** One packet has been receive **/	
	memcpy(capture->g_frame_data, (data+3), SIZE_FRAME);/** Save the picture (and its audio track) **/
	capture->g_nb_packet_attendu--; 
	/** we should update the data saving pointer **/
	capture->g_frame_data += SIZE_FRAME;
      }
    } //if found first frame
  }// if length
  return length;
}


int my_reset_handler(raw1394handle_t handle) {
  static int i = 0;
  capture_t *capture = (capture_t*)raw1394_get_userdata(handle);

  fprintf(stderr,"reset %d\n", i++);
  if (i == 100)
    capture->g_alldone = 1;
  return 0;
}



raw1394handle_t open_1394_driver(capture_t* capture, iso_handler_t iso_handler) {
  int numcards;
  struct raw1394_portinfo g_pinf[16];
  iso_handler_t	g_oldhandler;
  
  if (!(capture->handle = raw1394_get_handle())) {
    perror("raw1394 - couldn't get handle");
    exit( -1);
  }
  
  if ((numcards = raw1394_get_port_info(capture->handle, g_pinf, 16)) < 0) {
    perror("raw1394 - couldn't get card info");
    exit( -1);
  }
  
  if (raw1394_set_port(capture->handle, capture->g_card) < 0) {
    perror("raw1394 - couldn't set port");
    exit( -1);
  }
  
  g_oldhandler = raw1394_set_iso_handler(capture->handle, capture->g_channel, iso_handler);
  raw1394_set_bus_reset_handler(capture->handle, my_reset_handler);

  raw1394_set_userdata(capture->handle, capture);

  /* Starting iso receive */
  
  if (raw1394_start_iso_rcv(capture->handle, capture->g_channel) < 0) {
    perror("raw1394 - couldn't start iso receive");
    exit( -1);
  }
  return capture->handle;
}


void close_1394_driver(capture_t* capture) {
  raw1394_stop_fcp_listen(capture->handle);
  raw1394_destroy_handle(capture->handle);
}

static int flag_INT = 0;
void signal_handler(int sig){
  if (!flag_INT) {
    capture_globale->g_alldone = 1;
    flag_INT++;  
  } else if (flag_INT == 3 ){
    /** No more video hang capture **/
#ifdef OUTPUT_AVI
  if (capture_globale->g_avi_format) {
    capture_globale->g_avi->WriteRIFF();
    delete capture_globale->g_avi;
  }
#endif
    fprintf(stderr,"%d/%d frames shown (%.2f%%)\ndone",capture_globale->g_frame_decoded, capture_globale->g_frame_read, (double)(capture_globale->g_frame_decoded*100)/capture_globale->g_frame_read);
    close_capture(capture_globale);
    signal(SIGINT, SIG_DFL);
  } else {
    flag_INT++;
  }
}

void usage() {
  fprintf(stderr, "Usage: "PROGRAMNAME" [options]\n");
  fprintf(stderr, "Try "PROGRAMNAME" --help for more information\n");
}

void getargs(capture_t *capture, int argc, char *argv[]) {
  int i;
  int choose_format_image = 0;
  /* Set up all the defaults */
  capture->g_alldone = 0;
  capture->g_card = 0;
  capture->g_channel = 63;
  capture->g_frame_count = 10000; // nb image a restituer
  capture->g_file_out = NULL; // pas de fichier de sortie
  capture->g_file_in = NULL; // pas de fichier d'entre
  capture->g_stdout = 0; // pas de sortie standard
  capture->g_view = 1; // affiche la vue
  capture->g_son = 1; // decode de son
  capture->g_frame_size = NTSC_FRAME_SIZE;
  capture->g_nb_packet_frame = NB_PACKET_NTSC_FRAME;
#ifdef OUTPUT_AVI
  capture->g_avi_format = 0; //no avi
#endif
 
  for (i = 1; i < argc; ++i) {
    if ((strcmp("--frames", argv[i]) == 0) && (i+1 < argc)) {
      i++;
      if (sscanf(argv[i], "%d", &(capture->g_frame_count)) != 1) {
	usage();
	exit(1);
      }
    } else if ((strcmp("--card", argv[i]) == 0) && (i+1 < argc)) {
      i++;
      if (sscanf(argv[i], "%d", &(capture->g_card)) != 1) {
                                usage();
                                exit(1);
      }
    } else if ((strcmp("--channel", argv[i]) == 0) && (i+1 < argc)) {
      i++;
      if (sscanf(argv[i], "%d", &(capture->g_channel)) != 1) {
	usage();
	exit(1);
      }
    } else if ((strcmp("--of", argv[i]) == 0) && (i+1 < argc)) {
      i++;
      capture->g_file_out = argv[i];
#ifdef OUTPUT_AVI
    }  else if ((strcmp("--of_avi_type1", argv[i]) == 0) && (i+1 < argc)) {
      if (!capture->g_avi_format) {
	i++;
	capture->g_avi_format = 1;
	capture->g_file_out = argv[i];
      } else {
	usage();
	exit(1);
      }
    } else if ((strcmp("--of_avi_type2", argv[i]) == 0) && (i+1 < argc)) {
      if (!capture->g_avi_format) {
	i++;
 	capture->g_avi_format = 2;
	capture->g_file_out = argv[i];
     } else {
	usage();
	exit(1);
      }
#endif
    } else if ((strcmp("--if", argv[i]) == 0) && (i+1 < argc)) {
      i++;
      capture->g_file_in = argv[i];
    } else if ((strcmp("--o", argv[i]) == 0)) {
      capture->g_stdout = 1;
    } else if ((strcmp("--noview", argv[i]) == 0)) {
      capture->g_view = 0;
    } else if ((strcmp("--nosound", argv[i]) == 0)) {
      capture->g_son = 0;
    } else if (strcmp("--pal", argv[i]) == 0) {
      if (!choose_format_image) {
	capture->g_frame_size = PAL_FRAME_SIZE;
	capture->g_nb_packet_frame = NB_PACKET_PAL_FRAME;
	choose_format_image = 1;
      } else {
	usage();
	exit(1);
      }
    } else if (strcmp("--ntsc", argv[i]) == 0) {
      if (!choose_format_image) {
	capture->g_frame_size = NTSC_FRAME_SIZE;
	capture->g_nb_packet_frame = NB_PACKET_NTSC_FRAME;
 	choose_format_image = 1;
     } else {
	usage();
	exit(1);
      }
    } else if (strcmp("--help", argv[i]) == 0) {
      fprintf(stderr,"Usage: %s [options]\n", argv[0]);
      fprintf(stderr,"\nOptions:\n\n");
      fprintf(stderr,"  --frames number     number of frames to capture (default %d)\n", capture->g_frame_count);
      fprintf(stderr,"  --card number       card number (default %d)\n", capture->g_card);
      fprintf(stderr,"  --channel number    iso channel number for listening (default %d)\n", capture->g_channel);
      fprintf(stderr,"  [--pal | --ntsc ]   input data type (default NTSC)\n");
      fprintf(stderr,"  --of file           output DV file (default none)\n");
#ifdef OUTPUT_AVI
      fprintf(stderr,"  [--of_avi_type1 | --of_avi_type2] file \n"
	     "                      output AVI file \n");
#endif
      fprintf(stderr,"  --o                 output data on standard output (default no output)\n");
      fprintf(stderr,"  --if file           input file (default none)\n");
      fprintf(stderr,"  --noview            don't show the movie (default yes)\n");
      fprintf(stderr,"  --nosound           don't play sound (default yes, NTSC only)\n");
      fprintf(stderr,"  --help              display this help and exit\n");
      fprintf(stderr,"  --version           display version information and exit\n");
      exit(0);
    } else if (strcmp("--version", argv[i]) == 0) {
      fprintf(stderr,PROGRAMNAME" "VERSION"\n");
      exit(0);
    } else {
      usage();
      exit(1);
    }
  }  
}

int close_capture(capture_t *capture){
  if (capture){
    if (capture->g_view) { pthread_join(capture->g_view, NULL);  capture->g_view = 0;}
    if (capture->g_son) { pthread_join(capture->g_son, NULL);  capture->g_son = 0;}
    if (capture->g_frame) {
      free(capture->g_frame);
      capture->g_frame = 0;
    }
    if (capture->start_g_frame_data){
      free(capture->start_g_frame_data);
      capture->start_g_frame_data = 0;
    }
    close_3_buffer(capture->b_video);
    close_3_buffer(capture->b_son);
   }
   return 0;
}

/** Listen Iso Data **/
int capture_dv(capture_t *capture) {
  char  filename[256];

  open_1394_driver(capture, raw_iso_handler);

  capture->g_frame_read = 0;
  capture->g_frame_decoded = 0;
  capture->g_found_first_frame = false;
  capture->g_skipped = 0;

  capture->g_frame = 0;

  capture->g_frame_data = (unsigned char*)malloc(BUF_FRAME_DATA);
  capture->start_g_frame_data = capture->g_frame_data;

  capture->b_video = (triple_buff_t*)malloc(sizeof(triple_buff_t));
  capture->b_son = (triple_buff_t*)malloc(sizeof(triple_buff_t));
  init_3_buffer((capture->b_video), capture->g_frame_size);
  init_3_buffer((capture->b_son), capture->g_frame_size);

  if (capture->g_file_out) {
#ifdef OUTPUT_AVI
    switch (capture->g_avi_format){
    case 0 :
      sprintf(filename, "%s.dv", capture->g_file_out);
      if ((capture->g_fo = open(filename, O_WRONLY | O_CREAT, 00644)) < 0){
	perror("problem with output file");
	usage();
	exit(1);
      }
      break;
    case 1 :
      sprintf(filename, "%s.avi", capture->g_file_out);
      capture->g_avi = new AVI1File(filename);
      if (capture->g_frame_size == NTSC_FRAME_SIZE)
	capture->g_avi->Init(AVI_NTSC);
      else 
	capture->g_avi->Init(AVI_PAL);
      break;
    case 2 :
      sprintf(filename, "%s.avi", capture->g_file_out);
      capture->g_avi = new AVI2File(filename);
      if (capture->g_frame_size == NTSC_FRAME_SIZE)
	capture->g_avi->Init(AVI_NTSC);
      else 
	capture->g_avi->Init(AVI_PAL);
      break;
    }
#else
    sprintf(filename, "%s.dv", capture->g_file_out);
    if ((capture->g_fo = open(filename, O_WRONLY | O_CREAT, 00644)) < 0){
      perror("problem with output file");
      usage();
      exit(1);
    }
#endif
  } 

  while ((!(capture->g_alldone)) && (capture->g_frame_read < capture->g_frame_count)) {
    /** Wait for next iso packet **/
    raw1394_loop_iterate(capture->handle);
  } 
#ifdef OUTPUT_AVI
  if (capture->g_avi_format) {
    capture->g_avi->WriteRIFF();
    delete capture->g_avi;
  }
#endif
  fprintf(stderr,"%d/%d frames shown (%.2f%%)\n",capture->g_frame_decoded, capture->g_frame_read, (double)(capture->g_frame_decoded*100)/capture->g_frame_read); 
  close_1394_driver(capture);
  close_capture(capture);

  return 0;
}

/************************************************************************/
/*                         LECTURE D'UN FICHIER                         */
/**                          PLAY FROM A FILE                          **/
/************************************************************************/

#define NTSC_30HZ (33333)
#define PAL_25HZ (40000)


void programme_timer(capture_t *capture){
  static struct itimerval value;
  value.it_interval.tv_sec = 0;
  value.it_value.tv_sec = 0;
  if (capture->g_frame_size == NTSC_FRAME_SIZE) {
    value.it_interval.tv_usec = NTSC_30HZ;
    value.it_value.tv_usec = NTSC_30HZ; 
  } else {
    value.it_interval.tv_usec = PAL_25HZ; 
    value.it_value.tv_usec = PAL_25HZ; 
  }
  setitimer(ITIMER_REAL, &value, NULL);
}

/** The call-back reader **/
void read_dv_data(int unused){
  if (!(read(capture_globale->g_fi, capture_globale->g_frame, capture_globale->g_frame_size))) {
    struct itimerval value;
    // stop the timer
    value.it_interval.tv_usec = 0; 
    value.it_value.tv_usec = 0; 
    setitimer(ITIMER_REAL, &value, NULL);  
    capture_globale->g_alldone = 1;
    return;
  }
  if (capture_globale->g_file_out) {
#ifdef OUTPUT_AVI
	    switch (capture_globale->g_avi_format){
	    case 0 :
	      write(capture_globale->g_fo, capture_globale->g_frame, capture_globale->g_frame_size);
	      break;
	    case 1 :
	    case 2 :
	      capture_globale->g_avi->WriteFrame(capture_globale->g_frame, capture_globale->g_frame_size);
	      break;
	    }
#else
    write(capture_globale->g_fo, capture_globale->g_frame, capture_globale->g_frame_size );
#endif
  }
  if (capture_globale->g_view) bwrite(capture_globale->b_video, capture_globale->g_frame, capture_globale->g_frame_size);
  if (capture_globale->g_son) bwrite(capture_globale->b_son, capture_globale->g_frame, capture_globale->g_frame_size);
  if (capture_globale->g_stdout) write(1, capture_globale->g_frame, capture_globale->g_frame_size);
  if (capture_globale->g_frame[0] == 0x1f && capture_globale->g_frame[1] == 0x07){
    capture_globale->g_frame_read++; 
    if (capture_globale->g_frame_read > capture_globale->g_frame_count){
      struct itimerval value;
      value.it_interval.tv_usec = 0; 
      value.it_value.tv_usec = 0; 
      setitimer(ITIMER_REAL, &value, NULL);
      capture_globale->g_alldone = 1;
    }
  } 
}

/* Debute la lecture */
/** Start reading **/
int read_dv(capture_t *capture){
  char  filename[256];
  if (capture->g_file_out) {
#ifdef OUTPUT_AVI
    switch (capture->g_avi_format){
    case 0 :
      sprintf(filename, "%s.dv", capture->g_file_out);
      if ((capture->g_fo = open(filename, O_WRONLY | O_CREAT, 00644)) < 0){
	perror("problem with output file");
	usage();
	exit(1);
      }
      break;
    case 1 :
      sprintf(filename, "%s.avi", capture->g_file_out);
      capture->g_avi = new AVI1File(filename);
      if (capture->g_frame_size == NTSC_FRAME_SIZE)
	capture->g_avi->Init(AVI_NTSC);
      else 
	capture->g_avi->Init(AVI_PAL);
      break;
    case 2 :
      sprintf(filename, "%s.avi", capture->g_file_out);
      capture->g_avi = new AVI2File(filename);
      if (capture->g_frame_size == NTSC_FRAME_SIZE)
	capture->g_avi->Init(AVI_NTSC);
      else 
	capture->g_avi->Init(AVI_PAL);
      break;
    }
#else
    sprintf(filename, "%s.dv", capture->g_file_out);
    if ((capture->g_fo = open(filename, O_WRONLY | O_CREAT, 00644)) < 0){
      perror("problem with output file");
      usage();
      exit(1);
    }
#endif
  }
  if (capture->g_file_in){
    if ((capture->g_fi = open(capture->g_file_in, O_RDONLY, 00644)) < 0){
      perror("problem with input file");
      usage();
      exit(1);
    }
  } else {
    perror("problem with options");
    usage();
    exit(1);
  }

  capture->g_frame_read = 0;
  capture->g_frame_decoded = 0;
  capture->g_frame = (unsigned char*)malloc(capture->g_frame_size);
  capture->start_g_frame_data = NULL;
  capture->g_frame_data = NULL;

  capture->b_video = (triple_buff_t*)malloc(sizeof(triple_buff_t));
  capture->b_son = (triple_buff_t*)malloc(sizeof(triple_buff_t));
  init_3_buffer((capture->b_video), capture->g_frame_size);
  init_3_buffer((capture->b_son), capture->g_frame_size);

  if (capture->g_view) pthread_create(&(capture->player_video), NULL, (void * (*)(void *))playdv, capture);
  if (capture->g_son) pthread_create(&(capture->player_son), NULL, (void * (*)(void *))playdv_audio, capture);

  /** Playing : **/
  signal(SIGALRM, read_dv_data);
  programme_timer(capture);
  while (!(capture->g_alldone)){
    sleep(0);
  }
#ifdef OUTPUT_AVI
  if (capture->g_avi_format) {
    capture->g_avi->WriteRIFF();
    delete capture->g_avi;
  }
#endif

  /** Done **/

  fprintf(stderr,"%d/%d frames shown (%.2f%%)\n",capture->g_frame_decoded, capture->g_frame_read, (double)(capture->g_frame_decoded*100)/capture->g_frame_read);
  close_capture(capture);
  pthread_kill_other_threads_np();
  return 0;
}


int main(int argc, char *argv[]) {
  capture_t capture;
  /** for SIG handlers **/
  capture_globale = &capture;

  getargs(&capture, argc, argv);

  if (capture.g_file_in) {
    fprintf(stderr,"Reading...\n"); 
    signal(SIGINT, signal_handler);
    read_dv(&capture);
  } else {
    fprintf(stderr,"Waiting for iso data\n"); 
    capture_dv(&capture);
  }
  fprintf(stderr,"done\n");
  exit(0);
}
