#ifndef CAPTUREH
#define CAPTUREH

#include <assert.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

#include <libraw1394/raw1394.h>
#include <libraw1394/csr.h>

#include <pthread.h>
#include <signal.h>
#include <sys/time.h>

#include "triple_buffer.h"

#ifdef OUTPUT_AVI
#include "riff.h"
#include "avi.h"
#else
typedef void AVIFile;
#endif

#define RAW_BUF_SIZE	(15000)
#define BUF_FRAME_DATA	(150000)

#define NTSC_FRAME_SIZE (120000)
#define PAL_FRAME_SIZE  (144000)

#define NB_PACKET_NTSC_FRAME (250)
#define NB_PACKET_PAL_FRAME  (300)

#define SIZE_BIG_PACKET (496)
#define SIZE_FRAME (480)

#ifndef __cplusplus
typedef int bool;
enum {false, true};
#endif

typedef struct capture {

  raw1394handle_t handle;

  int	g_alldone;
  int	g_card;
  int	g_channel;
  /** Files inout **/
  char    *g_file_out;
  char    *g_file_in;
  int     g_fi;
  int     g_fo;

  int     g_avi_format;
  AVIFile *g_avi;

/** Flag stdout **/
  int     g_stdout; 

  /** Somes flags **/
  int     g_view; // show movie
  int     g_son; // play movie

  /** for the grabbing process **/
  int     g_frame_size; 
  int     g_nb_packet_frame;
  int     g_nb_packet_attendu;
  int     g_frame_count;
  int     g_frame_read;
  int     g_frame_decoded;
  bool    g_found_first_frame;
  int     g_skipped;

  unsigned char	  *g_frame;
  unsigned char   *g_frame_data;
  unsigned char   *start_g_frame_data; 

  /** PTHREADS OF CAPTURE **/
  pthread_t  player_video;
  pthread_t  player_son;
  /** Pthread Data communications **/
  triple_buff_t   *b_video; /** Pictures **/
  triple_buff_t   *b_son; /** Audio **/

} capture_t;

#endif
